rc.subr revision 193118
1# $NetBSD: rc.subr,v 1.67 2006/10/07 11:25:15 elad Exp $
2# $FreeBSD: head/etc/rc.subr 193118 2009-05-30 21:41:54Z dougb $
3#
4# Copyright (c) 1997-2004 The NetBSD Foundation, Inc.
5# All rights reserved.
6#
7# This code is derived from software contributed to The NetBSD Foundation
8# by Luke Mewburn.
9#
10# Redistribution and use in source and binary forms, with or without
11# modification, are permitted provided that the following conditions
12# are met:
13# 1. Redistributions of source code must retain the above copyright
14#    notice, this list of conditions and the following disclaimer.
15# 2. Redistributions in binary form must reproduce the above copyright
16#    notice, this list of conditions and the following disclaimer in the
17#    documentation and/or other materials provided with the distribution.
18# 3. All advertising materials mentioning features or use of this software
19#    must display the following acknowledgement:
20#        This product includes software developed by the NetBSD
21#        Foundation, Inc. and its contributors.
22# 4. Neither the name of The NetBSD Foundation nor the names of its
23#    contributors may be used to endorse or promote products derived
24#    from this software without specific prior written permission.
25#
26# THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
27# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
28# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
29# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
30# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
31# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
32# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
33# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
34# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
35# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
36# POSSIBILITY OF SUCH DAMAGE.
37#
38# rc.subr
39#	functions used by various rc scripts
40#
41
42: ${rcvar_manpage:='rc.conf(5)'}
43: ${RC_PID:=$$}; export RC_PID
44
45#
46#	Operating System dependent/independent variables
47#
48
49if [ -z "${_rc_subr_loaded}" ]; then
50
51_rc_subr_loaded="YES"
52
53SYSCTL="/sbin/sysctl"
54SYSCTL_N="${SYSCTL} -n"
55CMD_OSTYPE="${SYSCTL_N} kern.ostype"
56OSTYPE=`${CMD_OSTYPE}`
57ID="/usr/bin/id"
58IDCMD="if [ -x $ID ]; then $ID -un; fi"
59PS="/bin/ps -ww"
60JID=`$PS -p $$ -o jid=`
61
62case ${OSTYPE} in
63FreeBSD)
64	SYSCTL_W="${SYSCTL}"
65	;;
66NetBSD)
67	SYSCTL_W="${SYSCTL} -w"
68	;;
69esac
70
71#
72#	functions
73#	---------
74
75#
76# set_rcvar base_var
77#	Set the variable name enabling a specific service.
78#	FreeBSD uses ${service}_enable, while NetBSD uses
79#	just the name of the service. For example:
80#	FreeBSD: sendmail_enable="YES"
81#	NetBSD : sendmail="YES"
82#	$1 - if $name is not the base to work of off, specify
83#	     a different one
84#
85set_rcvar()
86{
87	if [ -z "$1" ]; then
88		base_var=${name}
89	else
90		base_var="$1"
91	fi
92
93	case ${OSTYPE} in
94	FreeBSD)
95		echo ${base_var}_enable
96		;;
97	NetBSD)
98		echo ${base_var}
99		;;
100	*)
101		echo 'XXX'
102		;;
103	esac
104}
105
106#
107# force_depend script
108#	Force a service to start. Intended for use by services
109#	to resolve dependency issues. It is assumed the caller
110#	has check to make sure this call is necessary
111#	$1 - filename of script, in /etc/rc.d, to run
112#
113force_depend()
114{
115	_depend="$1"
116
117	info "${name} depends on ${_depend}, which will be forced to start."
118	if ! /etc/rc.d/${_depend} forcestart; then
119		warn "Unable to force ${_depend}. It may already be running."
120		return 1
121	fi
122	return 0
123}
124
125#
126# checkyesno var
127#	Test $1 variable, and warn if not set to YES or NO.
128#	Return 0 if it's "yes" (et al), nonzero otherwise.
129#
130checkyesno()
131{
132	eval _value=\$${1}
133	debug "checkyesno: $1 is set to $_value."
134	case $_value in
135
136		#	"yes", "true", "on", or "1"
137	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
138		return 0
139		;;
140
141		#	"no", "false", "off", or "0"
142	[Nn][Oo]|[Ff][Aa][Ll][Ss][Ee]|[Oo][Ff][Ff]|0)
143		return 1
144		;;
145	*)
146		warn "\$${1} is not set properly - see ${rcvar_manpage}."
147		return 1
148		;;
149	esac
150}
151
152#
153# reverse_list list
154#	print the list in reverse order
155#
156reverse_list()
157{
158	_revlist=
159	for _revfile; do
160		_revlist="$_revfile $_revlist"
161	done
162	echo $_revlist
163}
164
165# stop_boot always
166#	If booting directly to multiuser or $always is enabled,
167#	send SIGTERM to the parent (/etc/rc) to abort the boot.
168#	Otherwise just exit.
169#
170stop_boot()
171{
172	local always
173
174	case $1 in
175		#	"yes", "true", "on", or "1"
176        [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
177		always=true
178		;;
179	*)
180		always=false
181		;;
182	esac
183	if [ "$autoboot" = yes -o "$always" = true ]; then
184		echo "ERROR: ABORTING BOOT (sending SIGTERM to parent)!"
185		kill -TERM ${RC_PID}
186	fi
187	exit 1
188}
189
190#
191# mount_critical_filesystems type
192#	Go through the list of critical filesystems as provided in
193#	the rc.conf(5) variable $critical_filesystems_${type}, checking
194#	each one to see if it is mounted, and if it is not, mounting it.
195#
196mount_critical_filesystems()
197{
198	eval _fslist=\$critical_filesystems_${1}
199	for _fs in $_fslist; do
200		mount | (
201			_ismounted=false
202			while read what _on on _type type; do
203				if [ $on = $_fs ]; then
204					_ismounted=true
205				fi
206			done
207			if $_ismounted; then
208				:
209			else
210				mount $_fs >/dev/null 2>&1
211			fi
212		)
213	done
214}
215
216#
217# check_pidfile pidfile procname [interpreter]
218#	Parses the first line of pidfile for a PID, and ensures
219#	that the process is running and matches procname.
220#	Prints the matching PID upon success, nothing otherwise.
221#	interpreter is optional; see _find_processes() for details.
222#
223check_pidfile()
224{
225	_pidfile=$1
226	_procname=$2
227	_interpreter=$3
228	if [ -z "$_pidfile" -o -z "$_procname" ]; then
229		err 3 'USAGE: check_pidfile pidfile procname [interpreter]'
230	fi
231	if [ ! -f $_pidfile ]; then
232		debug "pid file ($_pidfile): not readable."
233		return
234	fi
235	read _pid _junk < $_pidfile
236	if [ -z "$_pid" ]; then
237		debug "pid file ($_pidfile): no pid in file."
238		return
239	fi
240	_find_processes $_procname ${_interpreter:-.} '-p '"$_pid"
241}
242
243#
244# check_process procname [interpreter]
245#	Ensures that a process (or processes) named procname is running.
246#	Prints a list of matching PIDs.
247#	interpreter is optional; see _find_processes() for details.
248#
249check_process()
250{
251	_procname=$1
252	_interpreter=$2
253	if [ -z "$_procname" ]; then
254		err 3 'USAGE: check_process procname [interpreter]'
255	fi
256	_find_processes $_procname ${_interpreter:-.} '-ax'
257}
258
259#
260# _find_processes procname interpreter psargs
261#	Search for procname in the output of ps generated by psargs.
262#	Prints the PIDs of any matching processes, space separated.
263#
264#	If interpreter == ".", check the following variations of procname
265#	against the first word of each command:
266#		procname
267#		`basename procname`
268#		`basename procname` + ":"
269#		"(" + `basename procname` + ")"
270#		"[" + `basename procname` + "]"
271#
272#	If interpreter != ".", read the first line of procname, remove the
273#	leading #!, normalise whitespace, append procname, and attempt to
274#	match that against each command, either as is, or with extra words
275#	at the end.  As an alternative, to deal with interpreted daemons
276#	using perl, the basename of the interpreter plus a colon is also
277#	tried as the prefix to procname.
278#
279_find_processes()
280{
281	if [ $# -ne 3 ]; then
282		err 3 'USAGE: _find_processes procname interpreter psargs'
283	fi
284	_procname=$1
285	_interpreter=$2
286	_psargs=$3
287
288	_pref=
289	if [ $_interpreter != "." ]; then	# an interpreted script
290		_script=${_chroot}${_chroot:+"/"}$_procname
291		if [ -r $_script ]; then
292			read _interp < $_script	# read interpreter name
293			case "$_interp" in
294			\#!*)
295				_interp=${_interp#\#!}	# strip #!
296				set -- $_interp
297				case $1 in
298				*/bin/env)
299					shift	# drop env to get real name
300					;;
301				esac
302				if [ $_interpreter != $1 ]; then
303					warn "\$command_interpreter $_interpreter != $1"
304				fi
305				;;
306			*)
307				warn "no shebang line in $_script"
308				set -- $_interpreter
309				;;
310			esac
311		else
312			warn "cannot read shebang line from $_script"
313			set -- $_interpreter
314		fi
315		_interp="$* $_procname"		# cleanup spaces, add _procname
316		_interpbn=${1##*/}
317		_fp_args='_argv'
318		_fp_match='case "$_argv" in
319		    ${_interp}|"${_interp} "*|"${_interpbn}: ${_procname}"*)'
320	else					# a normal daemon
321		_procnamebn=${_procname##*/}
322		_fp_args='_arg0 _argv'
323		_fp_match='case "$_arg0" in
324		    $_procname|$_procnamebn|${_procnamebn}:|"(${_procnamebn})"|"[${_procnamebn}]")'
325	fi
326
327	_proccheck="\
328		$PS 2>/dev/null -o pid= -o jid= -o command= $_psargs"' |
329		while read _npid _jid '"$_fp_args"'; do
330			'"$_fp_match"'
331				if [ "$JID" -eq "$_jid" ];
332				then echo -n "$_pref$_npid";
333				_pref=" ";
334				fi
335				;;
336			esac
337		done'
338
339#	debug "in _find_processes: proccheck is ($_proccheck)."
340	eval $_proccheck
341}
342
343#
344# wait_for_pids pid [pid ...]
345#	spins until none of the pids exist
346#
347wait_for_pids()
348{
349	_list="$@"
350	if [ -z "$_list" ]; then
351		return
352	fi
353	_prefix=
354	while true; do
355		_nlist="";
356		for _j in $_list; do
357			if kill -0 $_j 2>/dev/null; then
358				_nlist="${_nlist}${_nlist:+ }$_j"
359			fi
360		done
361		if [ -z "$_nlist" ]; then
362			break
363		fi
364		_list=$_nlist
365		echo -n ${_prefix:-"Waiting for PIDS: "}$_list
366		_prefix=", "
367		sleep 2
368	done
369	if [ -n "$_prefix" ]; then
370		echo "."
371	fi
372}
373
374#
375# run_rc_command argument
376#	Search for argument in the list of supported commands, which is:
377#		"start stop restart rcvar status poll ${extra_commands}"
378#	If there's a match, run ${argument}_cmd or the default method
379#	(see below).
380#
381#	If argument has a given prefix, then change the operation as follows:
382#		Prefix	Operation
383#		------	---------
384#		fast	Skip the pid check, and set rc_fast=yes, rc_quiet=yes
385#		force	Set ${rcvar} to YES, and set rc_force=yes
386#		one	Set ${rcvar} to YES
387#		quiet	Don't output some diagnostics, and set rc_quiet=yes
388#
389#	The following globals are used:
390#
391#	Name		Needed	Purpose
392#	----		------	-------
393#	name		y	Name of script.
394#
395#	command		n	Full path to command.
396#				Not needed if ${rc_arg}_cmd is set for
397#				each keyword.
398#
399#	command_args	n	Optional args/shell directives for command.
400#
401#	command_interpreter n	If not empty, command is interpreted, so
402#				call check_{pidfile,process}() appropriately.
403#
404#	extra_commands	n	List of extra commands supported.
405#
406#	pidfile		n	If set, use check_pidfile $pidfile $command,
407#				otherwise use check_process $command.
408#				In either case, only check if $command is set.
409#
410#	procname	n	Process name to check for instead of $command.
411#
412#	rcvar		n	This is checked with checkyesno to determine
413#				if the action should be run.
414#
415#	${name}_program	n	Full path to command.
416#				Meant to be used in /etc/rc.conf to override
417#				${command}.
418#
419#	${name}_chroot	n	Directory to chroot to before running ${command}
420#				Requires /usr to be mounted.
421#
422#	${name}_chdir	n	Directory to cd to before running ${command}
423#				(if not using ${name}_chroot).
424#
425#	${name}_flags	n	Arguments to call ${command} with.
426#				NOTE:	$flags from the parent environment
427#					can be used to override this.
428#
429#	${name}_nice	n	Nice level to run ${command} at.
430#
431#	${name}_user	n	User to run ${command} as, using su(1) if not
432#				using ${name}_chroot.
433#				Requires /usr to be mounted.
434#
435#	${name}_group	n	Group to run chrooted ${command} as.
436#				Requires /usr to be mounted.
437#
438#	${name}_groups	n	Comma separated list of supplementary groups
439#				to run the chrooted ${command} with.
440#				Requires /usr to be mounted.
441#
442#	${rc_arg}_cmd	n	If set, use this as the method when invoked;
443#				Otherwise, use default command (see below)
444#
445#	${rc_arg}_precmd n	If set, run just before performing the
446#				${rc_arg}_cmd method in the default
447#				operation (i.e, after checking for required
448#				bits and process (non)existence).
449#				If this completes with a non-zero exit code,
450#				don't run ${rc_arg}_cmd.
451#
452#	${rc_arg}_postcmd n	If set, run just after performing the
453#				${rc_arg}_cmd method, if that method
454#				returned a zero exit code.
455#
456#	required_dirs	n	If set, check for the existence of the given
457#				directories before running a (re)start command.
458#
459#	required_files	n	If set, check for the readability of the given
460#				files before running a (re)start command.
461#
462#	required_modules n	If set, ensure the given kernel modules are
463#				loaded before running a (re)start command.
464#				The check and possible loads are actually
465#				done after start_precmd so that the modules
466#				aren't loaded in vain, should the precmd
467#				return a non-zero status to indicate a error.
468#				If a word in the list looks like "foo:bar",
469#				"foo" is the KLD file name and "bar" is the
470#				module name.  If a word looks like "foo~bar",
471#				"foo" is the KLD file name and "bar" is a
472#				egrep(1) pattern matching the module name.
473#				Otherwise the module name is assumed to be
474#				the same as the KLD file name, which is most
475#				common.  See load_kld().
476#
477#	required_vars	n	If set, perform checkyesno on each of the
478#				listed variables before running the default
479#				(re)start command.
480#
481#	Default behaviour for a given argument, if no override method is
482#	provided:
483#
484#	Argument	Default behaviour
485#	--------	-----------------
486#	start		if !running && checkyesno ${rcvar}
487#				${command}
488#
489#	stop		if ${pidfile}
490#				rc_pid=$(check_pidfile $pidfile $command)
491#			else
492#				rc_pid=$(check_process $command)
493#			kill $sig_stop $rc_pid
494#			wait_for_pids $rc_pid
495#			($sig_stop defaults to TERM.)
496#
497#	reload		Similar to stop, except use $sig_reload instead,
498#			and doesn't wait_for_pids.
499#			$sig_reload defaults to HUP.
500#			Note that `reload' isn't provided by default,
501#			it should be enabled via $extra_commands.
502#
503#	restart		Run `stop' then `start'.
504#
505#	status		Show if ${command} is running, etc.
506#
507#	poll		Wait for ${command} to exit.
508#
509#	rcvar		Display what rc.conf variable is used (if any).
510#
511#	Variables available to methods, and after run_rc_command() has
512#	completed:
513#
514#	Variable	Purpose
515#	--------	-------
516#	rc_arg		Argument to command, after fast/force/one processing
517#			performed
518#
519#	rc_flags	Flags to start the default command with.
520#			Defaults to ${name}_flags, unless overridden
521#			by $flags from the environment.
522#			This variable may be changed by the precmd method.
523#
524#	rc_pid		PID of command (if appropriate)
525#
526#	rc_fast		Not empty if "fast" was provided (q.v.)
527#
528#	rc_force	Not empty if "force" was provided (q.v.)
529#
530#	rc_quiet	Not empty if "quiet" was provided
531#
532#
533run_rc_command()
534{
535	_return=0
536	rc_arg=$1
537	if [ -z "$name" ]; then
538		err 3 'run_rc_command: $name is not set.'
539	fi
540
541	# Don't repeat the first argument when passing additional command-
542	# line arguments to the command subroutines.
543	#
544	shift 1
545	rc_extra_args="$*"
546
547	_rc_prefix=
548	case "$rc_arg" in
549	fast*)				# "fast" prefix; don't check pid
550		rc_arg=${rc_arg#fast}
551		rc_fast=yes
552		rc_quiet=yes
553		;;
554	force*)				# "force prefix; always run
555		rc_force=yes
556		_rc_prefix=force
557		rc_arg=${rc_arg#${_rc_prefix}}
558		if [ -n "${rcvar}" ]; then
559			eval ${rcvar}=YES
560		fi
561		;;
562	one*)				# "one" prefix; set ${rcvar}=yes
563		_rc_prefix=one
564		rc_arg=${rc_arg#${_rc_prefix}}
565		if [ -n "${rcvar}" ]; then
566			eval ${rcvar}=YES
567		fi
568		;;
569	quiet*)				# "quiet" prefix; omit some messages
570		_rc_prefix=quiet
571		rc_arg=${rc_arg#${_rc_prefix}}
572		rc_quiet=yes
573		;;
574	esac
575
576	eval _override_command=\$${name}_program
577	command=${command:+${_override_command:-$command}}
578
579	_keywords="start stop restart rcvar $extra_commands"
580	rc_pid=
581	_pidcmd=
582	_procname=${procname:-${command}}
583
584					# setup pid check command
585	if [ -n "$_procname" ]; then
586		if [ -n "$pidfile" ]; then
587			_pidcmd='rc_pid=$(check_pidfile '"$pidfile $_procname $command_interpreter"')'
588		else
589			_pidcmd='rc_pid=$(check_process '"$_procname $command_interpreter"')'
590		fi
591		if [ -n "$_pidcmd" ]; then
592			_keywords="${_keywords} status poll"
593		fi
594	fi
595
596	if [ -z "$rc_arg" ]; then
597		rc_usage $_keywords
598	fi
599
600	if [ -n "$flags" ]; then	# allow override from environment
601		rc_flags=$flags
602	else
603		eval rc_flags=\$${name}_flags
604	fi
605	eval _chdir=\$${name}_chdir	_chroot=\$${name}_chroot \
606	    _nice=\$${name}_nice	_user=\$${name}_user \
607	    _group=\$${name}_group	_groups=\$${name}_groups
608
609	if [ -n "$_user" ]; then	# unset $_user if running as that user
610		if [ "$_user" = "$(eval $IDCMD)" ]; then
611			unset _user
612		fi
613	fi
614
615	eval $_pidcmd			# determine the pid if necessary
616
617	for _elem in $_keywords; do
618		if [ "$_elem" != "$rc_arg" ]; then
619			continue
620		fi
621					# if ${rcvar} is set, and $1 is not
622					# "rcvar", then run
623					#	checkyesno ${rcvar}
624					# and return if that failed
625					#
626		if [ -n "${rcvar}" -a "$rc_arg" != "rcvar" ]; then
627			if ! checkyesno ${rcvar}; then
628				if [ -n "${rc_quiet}" ]; then
629					return 0
630				fi
631				echo -n "Cannot '${rc_arg}' $name. Set ${rcvar} to "
632				echo -n "YES in /etc/rc.conf or use 'one${rc_arg}' "
633				echo "instead of '${rc_arg}'."
634				return 0
635			fi
636		fi
637
638					# if there's a custom ${XXX_cmd},
639					# run that instead of the default
640					#
641		eval _cmd=\$${rc_arg}_cmd \
642		     _precmd=\$${rc_arg}_precmd \
643		     _postcmd=\$${rc_arg}_postcmd
644
645		if [ -n "$_cmd" ]; then
646			_run_rc_precmd || return 1
647			_run_rc_doit "$_cmd $rc_extra_args" || return 1
648			_run_rc_postcmd
649			return $_return
650		fi
651
652		case "$rc_arg" in	# default operations...
653
654		status)
655			_run_rc_precmd || return 1
656			if [ -n "$rc_pid" ]; then
657				echo "${name} is running as pid $rc_pid."
658			else
659				echo "${name} is not running."
660				return 1
661			fi
662			_run_rc_postcmd
663			;;
664
665		start)
666			if [ -z "$rc_fast" -a -n "$rc_pid" ]; then
667				echo 1>&2 "${name} already running? (pid=$rc_pid)."
668				return 1
669			fi
670
671			if [ ! -x ${_chroot}${_chroot:+"/"}${command} ]; then
672				warn "run_rc_command: cannot run $command"
673				return 1
674			fi
675
676			if ! _run_rc_precmd; then
677				warn "failed precmd routine for ${name}"
678				return 1
679			fi
680
681					# setup the full command to run
682					#
683			[ -z "${rc_quiet}" ] && echo "Starting ${name}."
684			if [ -n "$_chroot" ]; then
685				_doit="\
686${_nice:+nice -n $_nice }\
687chroot ${_user:+-u $_user }${_group:+-g $_group }${_groups:+-G $_groups }\
688$_chroot $command $rc_flags $command_args"
689			else
690				_doit="\
691${_chdir:+cd $_chdir && }\
692$command $rc_flags $command_args"
693				if [ -n "$_user" ]; then
694				    _doit="su -m $_user -c 'sh -c \"$_doit\"'"
695				fi
696				if [ -n "$_nice" ]; then
697					if [ -z "$_user" ]; then
698						_doit="sh -c \"$_doit\""
699					fi	
700					_doit="nice -n $_nice $_doit"
701				fi
702			fi
703
704					# run the full command
705					#
706			if ! _run_rc_doit "$_doit"; then
707				warn "failed to start ${name}"
708				return 1
709			fi
710
711					# finally, run postcmd
712					#
713			_run_rc_postcmd
714			;;
715
716		stop)
717			if [ -z "$rc_pid" ]; then
718				[ -n "$rc_fast" ] && return 0
719				_run_rc_notrunning
720				return 1
721			fi
722
723			_run_rc_precmd || return 1
724
725					# send the signal to stop
726					#
727			echo "Stopping ${name}."
728			_doit=$(_run_rc_killcmd "${sig_stop:-TERM}")
729			_run_rc_doit "$_doit" || return 1
730
731					# wait for the command to exit,
732					# and run postcmd.
733			wait_for_pids $rc_pid
734
735			_run_rc_postcmd
736			;;
737
738		reload)
739			if [ -z "$rc_pid" ]; then
740				_run_rc_notrunning
741				return 1
742			fi
743
744			_run_rc_precmd || return 1
745
746			_doit=$(_run_rc_killcmd "${sig_reload:-HUP}")
747			_run_rc_doit "$_doit" || return 1
748
749			_run_rc_postcmd
750			;;
751
752		restart)
753					# prevent restart being called more
754					# than once by any given script
755					#
756			if ${_rc_restart_done:-false}; then
757				return 0
758			fi
759			_rc_restart_done=true
760
761			_run_rc_precmd || return 1
762
763			# run those in a subshell to keep global variables
764			( run_rc_command ${_rc_prefix}stop $rc_extra_args )
765			( run_rc_command ${_rc_prefix}start $rc_extra_args )
766			_return=$?
767			[ $_return -ne 0 ] && [ -z "$rc_force" ] && return 1
768
769			_run_rc_postcmd
770			;;
771
772		poll)
773			_run_rc_precmd || return 1
774			if [ -n "$rc_pid" ]; then
775				wait_for_pids $rc_pid
776			fi
777			_run_rc_postcmd
778			;;
779
780		rcvar)
781			echo "# $name"
782			if [ -n "$rcvar" ]; then
783				if checkyesno ${rcvar}; then
784					echo "${rcvar}=YES"
785				else
786					echo "${rcvar}=NO"
787				fi
788			fi
789			;;
790
791		*)
792			rc_usage $_keywords
793			;;
794
795		esac
796		return $_return
797	done
798
799	echo 1>&2 "$0: unknown directive '$rc_arg'."
800	rc_usage $_keywords
801	# not reached
802}
803
804#
805# Helper functions for run_rc_command: common code.
806# They use such global variables besides the exported rc_* ones:
807#
808#	name	       R/W
809#	------------------
810#	_precmd		R
811#	_postcmd	R
812#	_return		W
813#
814_run_rc_precmd()
815{
816	check_required_before "$rc_arg" || return 1
817
818	if [ -n "$_precmd" ]; then
819		debug "run_rc_command: ${rc_arg}_precmd: $_precmd $rc_extra_args"
820		eval "$_precmd $rc_extra_args"
821		_return=$?
822
823		# If precmd failed and force isn't set, request exit.
824		if [ $_return -ne 0 ] && [ -z "$rc_force" ]; then
825			return 1
826		fi
827	fi
828
829	check_required_after "$rc_arg" || return 1
830
831	return 0
832}
833
834_run_rc_postcmd()
835{
836	if [ -n "$_postcmd" ]; then
837		debug "run_rc_command: ${rc_arg}_postcmd: $_postcmd $rc_extra_args"
838		eval "$_postcmd $rc_extra_args"
839		_return=$?
840	fi
841	return 0
842}
843
844_run_rc_doit()
845{
846	debug "run_rc_command: doit: $*"
847	eval "$@"
848	_return=$?
849
850	# If command failed and force isn't set, request exit.
851	if [ $_return -ne 0 ] && [ -z "$rc_force" ]; then
852		return 1
853	fi
854
855	return 0
856}
857
858_run_rc_notrunning()
859{
860	local _pidmsg
861
862	if [ -n "$pidfile" ]; then
863		_pidmsg=" (check $pidfile)."
864	else
865		_pidmsg=
866	fi
867	echo 1>&2 "${name} not running?${_pidmsg}"
868}
869
870_run_rc_killcmd()
871{
872	local _cmd
873
874	_cmd="kill -$1 $rc_pid"
875	if [ -n "$_user" ]; then
876		_cmd="su -m ${_user} -c 'sh -c \"${_cmd}\"'"
877	fi
878	echo "$_cmd"
879}
880
881#
882# run_rc_script file arg
883#	Start the script `file' with `arg', and correctly handle the
884#	return value from the script.  If `file' ends with `.sh', it's
885#	sourced into the current environment.  If `file' appears to be
886#	a backup or scratch file, ignore it.  Otherwise if it's
887#	executable run as a child process.
888#
889run_rc_script()
890{
891	_file=$1
892	_arg=$2
893	if [ -z "$_file" -o -z "$_arg" ]; then
894		err 3 'USAGE: run_rc_script file arg'
895	fi
896
897	unset	name command command_args command_interpreter \
898		extra_commands pidfile procname \
899		rcvar required_dirs required_files required_vars
900	eval unset ${_arg}_cmd ${_arg}_precmd ${_arg}_postcmd
901
902	case "$_file" in
903	/etc/rc.d/*.sh)			# no longer allowed in the base
904		warn "Ignoring old-style startup script $_file"
905		;;
906	*[~#]|*.OLD|*.bak|*.orig|*,v)	# scratch file; skip
907		warn "Ignoring scratch file $_file"
908		;;
909	*)				# run in subshell
910		if [ -x $_file ]; then
911			if [ -n "$rc_fast_and_loose" ]; then
912				set $_arg; . $_file
913			else
914				( trap "echo Script $_file interrupted; kill -QUIT $$" 3
915				  trap "echo Script $_file interrupted; exit 1" 2
916				  trap "echo Script $_file running" 29
917				  set $_arg; . $_file )
918			fi
919		fi
920		;;
921	esac
922}
923
924#
925# load_rc_config name
926#	Source in the configuration file for a given name.
927#
928load_rc_config()
929{
930	_name=$1
931	if [ -z "$_name" ]; then
932		err 3 'USAGE: load_rc_config name'
933	fi
934
935	if ${_rc_conf_loaded:-false}; then
936		:
937	else
938		if [ -r /etc/defaults/rc.conf ]; then
939			debug "Sourcing /etc/defaults/rc.conf"
940			. /etc/defaults/rc.conf
941			source_rc_confs
942		elif [ -r /etc/rc.conf ]; then
943			debug "Sourcing /etc/rc.conf (/etc/defaults/rc.conf doesn't exist)."
944			. /etc/rc.conf
945		fi
946		_rc_conf_loaded=true
947	fi
948	if [ -f /etc/rc.conf.d/"$_name" ]; then
949		debug "Sourcing /etc/rc.conf.d/${_name}"
950		. /etc/rc.conf.d/"$_name"
951	fi
952
953	# Old variable names support
954	#
955	[ -n "$enable_quotas" ] && quota_enable="$enable_quotas"
956}
957  
958#
959# load_rc_config_var name var
960#	Read the rc.conf(5) var for name and set in the
961#	current shell, using load_rc_config in a subshell to prevent
962#	unwanted side effects from other variable assignments.
963#
964load_rc_config_var()
965{
966	if [ $# -ne 2 ]; then
967		err 3 'USAGE: load_rc_config_var name var'
968	fi
969	eval $(eval '(
970		load_rc_config '$1' >/dev/null;
971                if [ -n "${'$2'}" -o "${'$2'-UNSET}" != "UNSET" ]; then
972			echo '$2'=\'\''${'$2'}\'\'';
973		fi
974	)' )
975}
976
977#
978# rc_usage commands
979#	Print a usage string for $0, with `commands' being a list of
980#	valid commands.
981#
982rc_usage()
983{
984	echo -n 1>&2 "Usage: $0 [fast|force|one]("
985
986	_sep=
987	for _elem; do
988		echo -n 1>&2 "$_sep$_elem"
989		_sep="|"
990	done
991	echo 1>&2 ")"
992	exit 1
993}
994
995#
996# err exitval message
997#	Display message to stderr and log to the syslog, and exit with exitval.
998#
999err()
1000{
1001	exitval=$1
1002	shift
1003
1004	if [ -x /usr/bin/logger ]; then
1005		logger "$0: ERROR: $*"
1006	fi
1007	echo 1>&2 "$0: ERROR: $*"
1008	exit $exitval
1009}
1010
1011#
1012# warn message
1013#	Display message to stderr and log to the syslog.
1014#
1015warn()
1016{
1017	if [ -x /usr/bin/logger ]; then
1018		logger "$0: WARNING: $*"
1019	fi
1020	echo 1>&2 "$0: WARNING: $*"
1021}
1022
1023#
1024# info message
1025#	Display informational message to stdout and log to syslog.
1026#
1027info()
1028{
1029	case ${rc_info} in
1030	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
1031		if [ -x /usr/bin/logger ]; then
1032			logger "$0: INFO: $*"
1033		fi
1034		echo "$0: INFO: $*"
1035		;;
1036	esac
1037}
1038
1039#
1040# debug message
1041#	If debugging is enabled in rc.conf output message to stderr.
1042#	BEWARE that you don't call any subroutine that itself calls this
1043#	function.
1044#
1045debug()
1046{
1047	case ${rc_debug} in
1048	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
1049		if [ -x /usr/bin/logger ]; then
1050			logger "$0: DEBUG: $*"
1051		fi
1052		echo 1>&2 "$0: DEBUG: $*"
1053		;;
1054	esac
1055}
1056
1057#
1058# backup_file action file cur backup
1059#	Make a backup copy of `file' into `cur', and save the previous
1060#	version of `cur' as `backup' or use rcs for archiving.
1061#
1062#	This routine checks the value of the backup_uses_rcs variable,
1063#	which can be either YES or NO.
1064#
1065#	The `action' keyword can be one of the following:
1066#
1067#	add		`file' is now being backed up (and is possibly
1068#			being reentered into the backups system).  `cur'
1069#			is created and RCS files, if necessary, are
1070#			created as well.
1071#
1072#	update		`file' has changed and needs to be backed up.
1073#			If `cur' exists, it is copied to to `back' or
1074#			checked into RCS (if the repository file is old),
1075#			and then `file' is copied to `cur'.  Another RCS
1076#			check in done here if RCS is being used.
1077#
1078#	remove		`file' is no longer being tracked by the backups
1079#			system.  If RCS is not being used, `cur' is moved
1080#			to `back', otherwise an empty file is checked in,
1081#			and then `cur' is removed.
1082#
1083#
1084backup_file()
1085{
1086	_action=$1
1087	_file=$2
1088	_cur=$3
1089	_back=$4
1090
1091	if checkyesno backup_uses_rcs; then
1092		_msg0="backup archive"
1093		_msg1="update"
1094
1095		# ensure that history file is not locked
1096		if [ -f $_cur,v ]; then
1097			rcs -q -u -U -M $_cur
1098		fi
1099
1100		# ensure after switching to rcs that the
1101		# current backup is not lost
1102		if [ -f $_cur ]; then
1103			# no archive, or current newer than archive
1104			if [ ! -f $_cur,v -o $_cur -nt $_cur,v ]; then
1105				ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
1106				rcs -q -kb -U $_cur
1107				co -q -f -u $_cur
1108			fi
1109		fi
1110
1111		case $_action in
1112		add|update)
1113			cp -p $_file $_cur
1114			ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
1115			rcs -q -kb -U $_cur
1116			co -q -f -u $_cur
1117			chown root:wheel $_cur $_cur,v
1118			;;
1119		remove)
1120			cp /dev/null $_cur
1121			ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
1122			rcs -q -kb -U $_cur
1123			chown root:wheel $_cur $_cur,v
1124			rm $_cur
1125			;;
1126		esac
1127	else
1128		case $_action in
1129		add|update)
1130			if [ -f $_cur ]; then
1131				cp -p $_cur $_back
1132			fi
1133			cp -p $_file $_cur
1134			chown root:wheel $_cur
1135			;;
1136		remove)
1137			mv -f $_cur $_back
1138			;;
1139		esac
1140	fi
1141}
1142
1143# make_symlink src link
1144#	Make a symbolic link 'link' to src from basedir. If the
1145#	directory in which link is to be created does not exist
1146#	a warning will be displayed and an error will be returned.
1147#	Returns 0 on sucess, 1 otherwise.
1148#
1149make_symlink()
1150{
1151	local src link linkdir _me
1152	src="$1"
1153	link="$2"
1154	linkdir="`dirname $link`"
1155	_me="make_symlink()"
1156
1157	if [ -z "$src" -o -z "$link" ]; then
1158		warn "$_me: requires two arguments."
1159		return 1
1160	fi
1161	if [ ! -d "$linkdir" ]; then
1162		warn "$_me: the directory $linkdir does not exist."
1163		return 1
1164	fi
1165	if ! ln -sf $src $link; then
1166		warn "$_me: unable to make a symbolic link from $link to $src"
1167		return 1
1168	fi
1169	return 0
1170}
1171
1172# devfs_rulesets_from_file file
1173#	Reads a set of devfs commands from file, and creates
1174#	the specified rulesets with their rules. Returns non-zero
1175#	if there was an error.
1176#
1177devfs_rulesets_from_file()
1178{
1179	local file _err _me
1180	file="$1"
1181	_me="devfs_rulesets_from_file"
1182	_err=0
1183
1184	if [ -z "$file" ]; then
1185		warn "$_me: you must specify a file"
1186		return 1
1187	fi
1188	if [ ! -e "$file" ]; then
1189		debug "$_me: no such file ($file)"
1190		return 0
1191	fi
1192	debug "reading rulesets from file ($file)"
1193	{ while read line
1194	do
1195		case $line in
1196		\#*)
1197			continue
1198			;;
1199		\[*\]*)
1200			rulenum=`expr "$line" : "\[.*=\([0-9]*\)\]"`
1201			if [ -z "$rulenum" ]; then
1202				warn "$_me: cannot extract rule number ($line)"
1203				_err=1
1204				break
1205			fi
1206			rulename=`expr "$line" : "\[\(.*\)=[0-9]*\]"`
1207			if [ -z "$rulename" ]; then
1208				warn "$_me: cannot extract rule name ($line)"
1209				_err=1
1210				break;
1211			fi
1212			eval $rulename=\$rulenum
1213			debug "found ruleset: $rulename=$rulenum"
1214			if ! /sbin/devfs rule -s $rulenum delset; then
1215				_err=1
1216				break
1217			fi
1218			;;
1219		*)
1220			rulecmd="${line%%"\#*"}"
1221			# evaluate the command incase it includes
1222			# other rules
1223			if [ -n "$rulecmd" ]; then
1224				debug "adding rule ($rulecmd)"
1225				if ! eval /sbin/devfs rule -s $rulenum $rulecmd
1226				then
1227					_err=1
1228					break
1229				fi
1230			fi
1231			;;
1232		esac
1233		if [ $_err -ne 0 ]; then
1234			debug "error in $_me"
1235			break
1236		fi
1237	done } < $file
1238	return $_err
1239}
1240
1241# devfs_init_rulesets
1242#	Initializes rulesets from configuration files. Returns
1243#	non-zero if there was an error.
1244#
1245devfs_init_rulesets()
1246{
1247	local file _me
1248	_me="devfs_init_rulesets"
1249
1250	# Go through this only once
1251	if [ -n "$devfs_rulesets_init" ]; then
1252		debug "$_me: devfs rulesets already initialized"
1253		return
1254	fi
1255	for file in $devfs_rulesets; do
1256		devfs_rulesets_from_file $file || return 1
1257	done
1258	devfs_rulesets_init=1
1259	debug "$_me: devfs rulesets initialized"
1260	return 0
1261}
1262
1263# devfs_set_ruleset ruleset [dir]
1264#	Sets the default ruleset of dir to ruleset. The ruleset argument
1265#	must be a ruleset name as specified in devfs.rules(5) file.
1266#	Returns non-zero if it could not set it successfully.
1267#
1268devfs_set_ruleset()
1269{
1270	local devdir rs _me
1271	[ -n "$1" ] && eval rs=\$$1 || rs=
1272	[ -n "$2" ] && devdir="-m "$2"" || devdir=
1273	_me="devfs_set_ruleset"
1274
1275	if [ -z "$rs" ]; then
1276		warn "$_me: you must specify a ruleset number"
1277		return 1
1278	fi
1279	debug "$_me: setting ruleset ($rs) on mount-point (${devdir#-m })"
1280	if ! /sbin/devfs $devdir ruleset $rs; then
1281		warn "$_me: unable to set ruleset $rs to ${devdir#-m }"
1282		return 1
1283	fi
1284	return 0
1285}
1286
1287# devfs_apply_ruleset ruleset [dir]
1288#	Apply ruleset number $ruleset to the devfs mountpoint $dir.
1289#	The ruleset argument must be a ruleset name as specified
1290#	in a devfs.rules(5) file.  Returns 0 on success or non-zero
1291#	if it could not apply the ruleset.
1292#
1293devfs_apply_ruleset()
1294{
1295	local devdir rs _me
1296	[ -n "$1" ] && eval rs=\$$1 || rs=
1297	[ -n "$2" ] && devdir="-m "$2"" || devdir=
1298	_me="devfs_apply_ruleset"
1299
1300	if [ -z "$rs" ]; then
1301		warn "$_me: you must specify a ruleset"
1302		return 1
1303	fi
1304	debug "$_me: applying ruleset ($rs) to mount-point (${devdir#-m })"
1305	if ! /sbin/devfs $devdir rule -s $rs applyset; then
1306		warn "$_me: unable to apply ruleset $rs to ${devdir#-m }"
1307		return 1
1308	fi
1309	return 0
1310}
1311
1312# devfs_domount dir [ruleset]
1313#	Mount devfs on dir. If ruleset is specified it is set
1314#	on the mount-point. It must also be a ruleset name as specified
1315#	in a devfs.rules(5) file. Returns 0 on success.
1316#
1317devfs_domount()
1318{
1319	local devdir rs _me
1320	devdir="$1"
1321	[ -n "$2" ] && rs=$2 || rs=
1322	_me="devfs_domount()"
1323
1324	if [ -z "$devdir" ]; then
1325		warn "$_me: you must specify a mount-point"
1326		return 1
1327	fi
1328	debug "$_me: mount-point is ($devdir), ruleset is ($rs)"
1329	if ! mount -t devfs dev "$devdir"; then
1330		warn "$_me: Unable to mount devfs on $devdir"
1331		return 1
1332	fi
1333	if [ -n "$rs" ]; then
1334		devfs_init_rulesets
1335		devfs_set_ruleset $rs $devdir
1336		devfs -m $devdir rule applyset
1337	fi
1338	return 0
1339}
1340
1341# devfs_mount_jail dir [ruleset]
1342#	Mounts a devfs file system appropriate for jails
1343#	on the directory dir. If ruleset is specified, the ruleset
1344#	it names will be used instead.  If present, ruleset must
1345#	be the name of a ruleset as defined in a devfs.rules(5) file.
1346#	This function returns non-zero if an error occurs.
1347#
1348devfs_mount_jail()
1349{
1350	local jdev rs _me
1351	jdev="$1"
1352	[ -n "$2" ] && rs=$2 || rs="devfsrules_jail"
1353	_me="devfs_mount_jail"
1354
1355	devfs_init_rulesets
1356	if ! devfs_domount "$jdev" $rs; then
1357		warn "$_me: devfs was not mounted on $jdev"
1358		return 1
1359	fi
1360	return 0
1361}
1362
1363# Provide a function for normalizing the mounting of memory
1364# filesystems.  This should allow the rest of the code here to remain
1365# as close as possible between 5-current and 4-stable.
1366#   $1 = size
1367#   $2 = mount point
1368#   $3 = (optional) extra mdmfs flags
1369mount_md()
1370{
1371	if [ -n "$3" ]; then
1372		flags="$3"
1373	fi
1374	/sbin/mdmfs $flags -s $1 md $2
1375}
1376
1377# Code common to scripts that need to load a kernel module
1378# if it isn't in the kernel yet. Syntax:
1379#   load_kld [-e regex] [-m module] file
1380# where -e or -m chooses the way to check if the module
1381# is already loaded:
1382#   regex is egrep'd in the output from `kldstat -v',
1383#   module is passed to `kldstat -m'.
1384# The default way is as though `-m file' were specified.
1385load_kld()
1386{
1387	local _loaded _mod _opt _re
1388
1389	while getopts "e:m:" _opt; do
1390		case "$_opt" in
1391		e) _re="$OPTARG" ;;
1392		m) _mod="$OPTARG" ;;
1393		*) err 3 'USAGE: load_kld [-e regex] [-m module] file' ;;
1394		esac
1395	done
1396	shift $(($OPTIND - 1))
1397	if [ $# -ne 1 ]; then
1398		err 3 'USAGE: load_kld [-e regex] [-m module] file'
1399	fi
1400	_mod=${_mod:-$1}
1401	_loaded=false
1402	if [ -n "$_re" ]; then
1403		if kldstat -v | egrep -q -e "$_re"; then
1404			_loaded=true
1405		fi
1406	else
1407		if kldstat -q -m "$_mod"; then
1408			_loaded=true
1409		fi
1410	fi
1411	if ! $_loaded; then
1412		if ! kldload "$1"; then
1413			warn "Unable to load kernel module $1"
1414			return 1
1415		else
1416			info "$1 kernel module loaded."
1417		fi
1418	else
1419		debug "load_kld: $1 kernel module already loaded."
1420	fi
1421	return 0
1422}
1423
1424# ltr str src dst
1425#	Change every $src in $str to $dst.
1426#	Useful when /usr is not yet mounted and we cannot use tr(1), sed(1) nor
1427#	awk(1).
1428ltr()
1429{
1430	local _str _src _dst _out _com
1431	_str=$1
1432	_src=$2
1433	_dst=$3
1434	_out=""
1435
1436	IFS=${_src}
1437	for _com in ${_str}; do
1438		if [ -z "${_out}" ]; then
1439			_out="${_com}"
1440		else
1441			_out="${_out}${_dst}${_com}"
1442		fi
1443	done
1444	echo "${_out}"
1445}
1446
1447# Creates a list of providers for GELI encryption.
1448geli_make_list()
1449{
1450	local devices devices2
1451	local provider mountpoint type options rest
1452
1453	# Create list of GELI providers from fstab.
1454	while read provider mountpoint type options rest ; do
1455		case ":${options}" in
1456		:*noauto*)
1457			noauto=yes
1458			;;
1459		*)
1460			noauto=no
1461			;;
1462		esac
1463
1464		case ":${provider}" in
1465		:#*)
1466			continue
1467			;;
1468		*.eli)
1469			# Skip swap devices.
1470			if [ "${type}" = "swap" -o "${options}" = "sw" -o "${noauto}" = "yes" ]; then
1471				continue
1472			fi
1473			devices="${devices} ${provider}"
1474			;;
1475		esac
1476	done < /etc/fstab
1477
1478	# Append providers from geli_devices.
1479	devices="${devices} ${geli_devices}"
1480
1481	for provider in ${devices}; do
1482		provider=${provider%.eli}
1483		provider=${provider#/dev/}
1484		devices2="${devices2} ${provider}"
1485	done
1486
1487	echo ${devices2}
1488}
1489
1490# Find scripts in local_startup directories that use the old syntax
1491#
1492find_local_scripts_old () {
1493	zlist=''
1494	slist=''
1495	for dir in ${local_startup}; do
1496		if [ -d "${dir}" ]; then
1497			for file in ${dir}/[0-9]*.sh; do
1498				grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
1499				    continue
1500				zlist="$zlist $file"
1501			done
1502			for file in ${dir}/[^0-9]*.sh; do
1503				grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
1504				    continue
1505				slist="$slist $file"
1506			done
1507		fi
1508	done
1509}
1510
1511find_local_scripts_new () {
1512	local_rc=''
1513	for dir in ${local_startup}; do
1514		if [ -d "${dir}" ]; then
1515			for file in `grep -l '^# PROVIDE:' ${dir}/* 2>/dev/null`; do
1516				case "$file" in
1517				*.sample) ;;
1518				*)	if [ -x "$file" ]; then
1519						local_rc="${local_rc} ${file}"
1520					fi
1521					;;
1522				esac
1523			done
1524		fi
1525	done
1526}
1527
1528# check_required_{before|after} command
1529#	Check for things required by the command before and after its precmd,
1530#	respectively.  The two separate functions are needed because some
1531#	conditions should prevent precmd from being run while other things
1532#	depend on precmd having already been run.
1533#
1534check_required_before()
1535{
1536	local _f
1537
1538	case "$1" in
1539	start)
1540		for _f in $required_vars; do
1541			if ! checkyesno $_f; then
1542				warn "\$${_f} is not enabled."
1543				if [ -z "$rc_force" ]; then
1544					return 1
1545				fi
1546			fi
1547		done
1548
1549		for _f in $required_dirs; do
1550			if [ ! -d "${_f}/." ]; then
1551				warn "${_f} is not a directory."
1552				if [ -z "$rc_force" ]; then
1553					return 1
1554				fi
1555			fi
1556		done
1557
1558		for _f in $required_files; do
1559			if [ ! -r "${_f}" ]; then
1560				warn "${_f} is not readable."
1561				if [ -z "$rc_force" ]; then
1562					return 1
1563				fi
1564			fi
1565		done
1566		;;
1567	esac
1568
1569	return 0
1570}
1571
1572check_required_after()
1573{
1574	local _f _args
1575
1576	case "$1" in
1577	start)
1578		for _f in $required_modules; do
1579			case "${_f}" in
1580				*~*)	_args="-e ${_f#*~} ${_f%%~*}" ;;
1581				*:*)	_args="-m ${_f#*:} ${_f%%:*}" ;;
1582				*)	_args="${_f}" ;;
1583			esac
1584			if ! load_kld ${_args}; then
1585				if [ -z "$rc_force" ]; then
1586					return 1
1587				fi
1588			fi
1589		done
1590		;;
1591	esac
1592
1593	return 0
1594}
1595
1596fi
1597
1598_rc_subr_loaded=:
1599